CHero = class:new()

function CHero:init (x, y)
	self.x 				= x or 300
	self.y 				= y or 210
	self.width 			= gTileSize
	self.height 		= (2 * gTileSize)
	
	self.spX 			= 0
	self.maxSpX 		= 1000
	self.acc 			= 5
	self.dec 			= 10
	self.friction 		= 5
	
	self.color 			= { 255, 0, 0, 255 }
end

function CHero:update(dt)
	self:updateSpeedX2(dt)
	self:updatePosition(dt)
end


function CHero:updateSpeedX2(dt)
	if (gKeyPressed.left) then 
		if (self.spX > 0) then self.spX = self.spX - (self.dec * dt)
		elseif (self.spX > -self.maxSpX) then self.spX = self.spX - (self.acc * dt)
		end
	elseif (gKeyPressed.right) then 
		if (self.spX < 0) then self.spX = self.spX + (self.dec * dt )
		elseif (self.spX < self.maxSpX) then self.spX = self.spX + (self.acc * dt)
		end
	else 
		self.spX = self.spX - math.min(math.abs(self.spX), (self.friction)) * math.sign (self.spX)
	end
	
end


-- UPDATE POSITION
function CHero:updatePosition(dt)
	self.x = self.x + (self.spX)
end


--DRAW
function CHero:draw()
	love.graphics.setColor(self.color)
	love.graphics.rectangle('fill', self.x, self.y, self.width, -self.height)
	love.graphics.setColor(255,255,255)
end
