function math.clamp(x, min, max)
  return x < min and min or (x > max and max or x)
end


function isInTable(t, key)
	-- print ("key to check: " .. key)
	-- print ("array to check: " .. t)
	for _,v in pairs(t) do
		if v == key then
			-- print "FOUND!"
			return true
		end
	end
	-- print "NOT FOUND!"
	return false
end


function printError (message)
	print ("[ERROR] " .. message)
end


function printDebug (message)
	print ("[DEBUG] " .. message)
end


function printWarning (message)
	print ("[WARNING] " .. message)
end



function math.sign(x)
	if x<0 then
		return -1
	elseif x>0 then
		return 1
	else
		return 0
	end
end


-- LoadXML from http://lua-users.org/wiki/LuaXml
function LoadXML(s)
	local function LoadXML_parseargs(s)
		local arg = {}
		string.gsub(s, "(%w+)=([\"'])(.-)%2", function (w, _, a)
		arg[w] = a
		end)
		return arg
	end
  
	local stack = {}
	local top = {}
	table.insert(stack, top)
	local ni,c,label,xarg, empty
	local i, j = 1, 1
	while true do
		ni,j,c,label,xarg, empty = string.find(s, "<(%/?)([%w:]+)(.-)(%/?)>", i)
		if not ni then break end
		local text = string.sub(s, i, ni-1)
		if not string.find(text, "^%s*$") then
			table.insert(top, text)
		end
		if empty == "/" then  -- empty element tag
			table.insert(top, {label=label, xarg=LoadXML_parseargs(xarg), empty=1})
		elseif c == "" then   -- start tag
			top = {label=label, xarg=LoadXML_parseargs(xarg)}
			table.insert(stack, top)   -- new level
		else  -- end tag
			local toclose = table.remove(stack)  -- remove top
			top = stack[#stack]
			if #stack < 1 then
				error("nothing to close with "..label)
			end
			if toclose.label ~= label then
				error("trying to close "..toclose.label.." with "..label)
			end
			table.insert(top, toclose)
		end
		i = j+1
	end
  
	local text = string.sub(s, i)
  
	if not string.find(text, "^%s*$") then
		table.insert(stack[#stack], text)
	end
  
	if #stack > 1 then
		error("unclosed "..stack[stack.n].label)
	end
	return stack[1]
end


function round(x) 
	return (x < 0) and -round (-x) or math.floor(x)
        -- if x < 0 then return -round(-x) end 
        -- return  math.floor(x) 
end 