-- includes
require("globals")
require("lib/misc")
require("lib/class")
require("lib/camera")
require("class/characters/hero")


function love.load()
	love.window.setMode (1280, 720, {fullscreen = false, vsync = false, msaa = 0} )
  
	hero = CHero:new(256, 256)
	
	camera:setBounds(0, 0, (100 * gTileSize) - love.graphics.getWidth(), (20 * gTileSize) - love.graphics.getHeight())
end


function love.keyreleased( key )
	gKeyPressed[key] = nil
end

function love.keypressed( key, unicode ) 
	gKeyPressed[key] = true 
	
	if (key == "escape") then os.exit(0) end
	if (key == "d") then gDrawDebug = not gDrawDebug end
end


function love.update( dt )
	hero:update(dt)
	camera:setPosition(hero.x - love.graphics.getWidth() / 2, hero.y - love.graphics.getHeight() / 2)
end


function drawDebug ()
	local x, y = 0, 0

	love.graphics.setColor(100,100,100, 150)
	love.graphics.rectangle('fill', x, y, 200, 80)
	love.graphics.setColor(255,255,255)
	
	love.graphics.print("FPS: " .. love.timer.getFPS(), x + 2, y + 2)
	love.graphics.print("x-y: " .. math.floor(hero.x) .. ", " .. math.floor(hero.y), x + 2, y + 20)
	love.graphics.print("speed: " .. round(hero.spX), x + 2, y + 40)
	love.graphics.print("accelX: " .. hero.acc, x + 2, y + 60)
end

function drawSomeTempStuff()
	for i = 0, 30, 2 do
		for j = 0, 10, 2 do
			love.graphics.setColor(0, 100, 0)
			love.graphics.rectangle('fill', i * gTileSize, j * gTileSize, gTileSize, gTileSize)
			love.graphics.setColor(255,255,255)
		end
	end

end

function love.draw()
	love.graphics.setBackgroundColor(150,150,255)
	camera:set()
		drawSomeTempStuff()
		hero:draw()
	camera:unset()
	
	if (gDrawDebug) then drawDebug() end
end
